/*
 * Use swi instruction.
 * See gdb/sim/moxie/interp.c:sim_engine_run()
 * (case 0x30:)
 */

#define SYS_exit  1
#define SYS_open  2
#define SYS_close /* not defined */
#define SYS_read  4
#define SYS_write 5

	.section .text

	.globl	_start
	.type	_start, @function
_start:
	ldi.l	$sp, _estack
	jsra	main

	/*
	 * Registers as return value and first argument are same.
	 * Setup of first argument is unneed.
	 */
	/* fall through */

	.globl	__exit
	.type	__exit, @function
__exit:
	swi	SYS_exit
	ret

	.globl	__read
	.type	__read, @function
__read:
	swi	SYS_read
	ret

	.globl	__write
	.type	__write, @function
__write:
	swi	SYS_write
	ret

	.globl	__open
	.type	__open, @function
__open:
	/*
	 * There is a bug in the open system call.
	 * System call is called before reading the file name.
	 * At first call, read the file name.
	 * At Second call, call the open system call.
	 * See gdb/sim/moxie/interp.c:sim_engine_run() (case 0x2:)
	 */
#if 1
	mov	$r3, $r0
	swi	SYS_open
	mov	$r0, $r3
	swi	SYS_open
#else
	ldi.l	$r0, -1
#endif
	ret

	.globl	__close
	.type	__close, @function
__close:
	/* not defined */
	ldi.l	$r0, -1
	ret
